Clazz.declarePackage ("jalview.appletgui");
Clazz.load (["jalview.appletgui.EmbmenuFrame", "java.awt.event.ActionListener", "$.ItemListener", "java.lang.Thread", "awt2swing.CheckboxMenuItem", "$.Menu", "$.MenuBar", "$.MenuItem", "$.ScrollPane", "java.awt.BorderLayout"], "jalview.appletgui.TreePanel", ["awt2swing.Frame", "jalview.analysis.NJTree", "jalview.api.analysis.ViewBasedAnalysisI", "jalview.appletgui.AlignFrame", "$.CutAndPasteTransfer", "$.FontChooser", "$.TreeCanvas", "jalview.bin.JalviewLite", "jalview.datamodel.Alignment", "jalview.io.NewickFile", "jalview.schemes.ResidueProperties", "jalview.util.MessageManager", "java.awt.Color", "$.Font"], function () {
c$ = Clazz.decorateAsClass (function () {
this.seq = null;
this.$type = null;
this.pwtype = null;
this.start = 0;
this.end = 0;
this.treeCanvas = null;
this.tree = null;
this.ap = null;
this.av = null;
if (!Clazz.isClassDefined ("jalview.appletgui.TreePanel.TreeLoader")) {
jalview.appletgui.TreePanel.$TreePanel$TreeLoader$ ();
}
this.borderLayout1 = null;
this.scrollPane = null;
this.jMenuBar1 = null;
this.jMenu2 = null;
this.fontSize = null;
this.bootstrapMenu = null;
this.distanceMenu = null;
this.placeholdersMenu = null;
this.fitToWindow = null;
this.fileMenu = null;
this.newickOutput = null;
this.inputData = null;
Clazz.instantialize (this, arguments);
}, jalview.appletgui, "TreePanel", jalview.appletgui.EmbmenuFrame, [java.awt.event.ActionListener, java.awt.event.ItemListener]);
Clazz.prepareFields (c$, function () {
this.borderLayout1 =  new java.awt.BorderLayout ();
this.scrollPane =  new awt2swing.ScrollPane ();
this.jMenuBar1 =  new awt2swing.MenuBar ();
this.jMenu2 =  new awt2swing.Menu ();
this.fontSize =  new awt2swing.MenuItem ();
this.bootstrapMenu =  new awt2swing.CheckboxMenuItem ();
this.distanceMenu =  new awt2swing.CheckboxMenuItem ();
this.placeholdersMenu =  new awt2swing.CheckboxMenuItem ();
this.fitToWindow =  new awt2swing.CheckboxMenuItem ();
this.fileMenu =  new awt2swing.Menu ();
this.newickOutput =  new awt2swing.MenuItem ();
this.inputData =  new awt2swing.MenuItem ();
});
Clazz.defineMethod (c$, "getTree", 
function () {
return this.tree;
});
Clazz.defineMethod (c$, "finalize", 
function () {
this.ap = null;
this.av = null;
Clazz.superCall (this, jalview.appletgui.TreePanel, "finalize", []);
});
Clazz.makeConstructor (c$, 
function (ap, type, pwtype) {
Clazz.superConstructor (this, jalview.appletgui.TreePanel, []);
try {
this.jbInit ();
this.setMenuBar (this.jMenuBar1);
} catch (ex) {
if (Clazz.exceptionOf (ex, Exception)) {
ex.printStackTrace ();
} else {
throw ex;
}
}
this.initTreePanel (ap, type, pwtype, null);
}, "jalview.appletgui.AlignmentPanel,~S,~S");
Clazz.makeConstructor (c$, 
function (ap, type, pwtype, newtree) {
Clazz.superConstructor (this, jalview.appletgui.TreePanel, []);
try {
this.jbInit ();
this.setMenuBar (this.jMenuBar1);
} catch (e) {
if (Clazz.exceptionOf (e, Exception)) {
e.printStackTrace ();
} else {
throw e;
}
}
this.initTreePanel (ap, type, pwtype, newtree);
}, "jalview.appletgui.AlignmentPanel,~S,~S,jalview.io.NewickFile");
Clazz.defineMethod (c$, "initTreePanel", 
function (ap, type, pwtype, newTree) {
this.ap = ap;
this.av = ap.av;
this.$type = type;
this.pwtype = pwtype;
this.treeCanvas =  new jalview.appletgui.TreeCanvas (ap, this.scrollPane);
var tl = Clazz.innerTypeInstance (jalview.appletgui.TreePanel.TreeLoader, this, null, newTree);
tl.start ();
this.embedMenuIfNeeded (this.treeCanvas);
this.scrollPane.add (this.treeCanvas, "Center");
}, "jalview.appletgui.AlignmentPanel,~S,~S,jalview.io.NewickFile");
Clazz.defineMethod (c$, "showOriginalData", 
function () {
if (this.tree.seqData != null) {
var gc = '-';
try {
gc = this.av.getGapCharacter ();
} catch (ex) {
if (Clazz.exceptionOf (ex, Exception)) {
} else {
throw ex;
}
}
;var alAndColsel = this.tree.seqData.getAlignmentAndColumnSelection (gc);
if (alAndColsel != null && alAndColsel[0] != null) {
var al =  new jalview.datamodel.Alignment (alAndColsel[0]);
var af =  new jalview.appletgui.AlignFrame (al, this.av.applet, "Original Data for Tree", false);
af.viewport.setHiddenColumns (alAndColsel[1]);
}} else {
System.out.println ("Original Tree Data not available");
}});
Clazz.overrideMethod (c$, "actionPerformed", 
function (evt) {
if (evt.getSource () === this.newickOutput) {
this.newickOutput_actionPerformed ();
} else if (evt.getSource () === this.fontSize) {
this.fontSize_actionPerformed ();
} else if (evt.getSource () === this.inputData) {
this.showOriginalData ();
}}, "java.awt.event.ActionEvent");
Clazz.overrideMethod (c$, "itemStateChanged", 
function (evt) {
if (evt.getSource () === this.fitToWindow) {
this.treeCanvas.fitToWindow = this.fitToWindow.getState ();
} else if (evt.getSource () === this.distanceMenu) {
this.treeCanvas.setShowDistances (this.distanceMenu.getState ());
} else if (evt.getSource () === this.bootstrapMenu) {
this.treeCanvas.setShowBootstrap (this.bootstrapMenu.getState ());
} else if (evt.getSource () === this.placeholdersMenu) {
this.treeCanvas.setMarkPlaceholders (this.placeholdersMenu.getState ());
}this.treeCanvas.repaint ();
}, "java.awt.event.ItemEvent");
Clazz.defineMethod (c$, "newickOutput_actionPerformed", 
function () {
var fout =  new jalview.io.NewickFile (this.tree.getTopNode ());
var output = fout.print (false, true);
var cap =  new jalview.appletgui.CutAndPasteTransfer (false, null);
cap.setText (output);
var frame =  new awt2swing.Frame ();
frame.add (cap);
jalview.bin.JalviewLite.addFrame (frame, this.$type + " " + this.pwtype, 500, 100);
});
Clazz.defineMethod (c$, "getTreeFont", 
function () {
return this.treeCanvas.$font;
});
Clazz.defineMethod (c$, "setTreeFont", 
function (font) {
this.treeCanvas.$font = font;
this.treeCanvas.repaint ();
}, "java.awt.Font");
Clazz.defineMethod (c$, "fontSize_actionPerformed", 
function () {
if (this.treeCanvas == null) {
return;
} new jalview.appletgui.FontChooser (this);
});
Clazz.defineMethod (c$, "jbInit", 
 function () {
this.setLayout (this.borderLayout1);
this.setBackground (java.awt.Color.white);
this.setFont ( new java.awt.Font ("Verdana", 0, 12));
this.jMenu2.setLabel (jalview.util.MessageManager.getString ("action.view"));
this.fontSize.setLabel (jalview.util.MessageManager.getString ("action.font"));
this.fontSize.addActionListener (this);
this.bootstrapMenu.setLabel (jalview.util.MessageManager.getString ("label.show_bootstrap_values"));
this.bootstrapMenu.addItemListener (this);
this.distanceMenu.setLabel (jalview.util.MessageManager.getString ("label.show_distances"));
this.distanceMenu.addItemListener (this);
this.placeholdersMenu.setLabel (jalview.util.MessageManager.getString ("label.mark_unassociated_leaves"));
this.placeholdersMenu.addItemListener (this);
this.fitToWindow.setState (true);
this.fitToWindow.setLabel (jalview.util.MessageManager.getString ("label.fit_to_window"));
this.fitToWindow.addItemListener (this);
this.fileMenu.setLabel (jalview.util.MessageManager.getString ("action.file"));
this.newickOutput.setLabel (jalview.util.MessageManager.getString ("label.newick_format"));
this.newickOutput.addActionListener (this);
this.inputData.setLabel (jalview.util.MessageManager.getString ("label.input_data"));
this.add (this.scrollPane, "Center");
this.jMenuBar1.add (this.fileMenu);
this.jMenuBar1.add (this.jMenu2);
this.jMenu2.add (this.fitToWindow);
this.jMenu2.add (this.fontSize);
this.jMenu2.add (this.distanceMenu);
this.jMenu2.add (this.bootstrapMenu);
this.jMenu2.add (this.placeholdersMenu);
this.fileMenu.add (this.newickOutput);
this.fileMenu.add (this.inputData);
this.inputData.addActionListener (this);
});
c$.$TreePanel$TreeLoader$ = function () {
Clazz.pu$h(self.c$);
c$ = Clazz.decorateAsClass (function () {
Clazz.prepareCallback (this, arguments);
this.newtree = null;
this.odata = null;
Clazz.instantialize (this, arguments);
}, jalview.appletgui.TreePanel, "TreeLoader", Thread);
Clazz.makeConstructor (c$, 
function (a) {
Clazz.superConstructor (this, jalview.appletgui.TreePanel.TreeLoader, []);
this.newtree = a;
}, "jalview.io.NewickFile");
Clazz.overrideMethod (c$, "run", 
function () {
if (this.newtree != null) {
if (this.odata == null) {
this.b$["jalview.appletgui.TreePanel"].tree =  new jalview.analysis.NJTree (this.b$["jalview.appletgui.TreePanel"].av.getAlignment ().getSequencesArray (), this.newtree);
} else {
this.b$["jalview.appletgui.TreePanel"].tree =  new jalview.analysis.NJTree (this.b$["jalview.appletgui.TreePanel"].av.getAlignment ().getSequencesArray (), this.odata, this.newtree);
}} else {
var a;
var b;
var c;
var d = this.b$["jalview.appletgui.TreePanel"].av.getSelectionGroup () != null && this.b$["jalview.appletgui.TreePanel"].av.getSelectionGroup ().getSize () > 1;
var e = this.b$["jalview.appletgui.TreePanel"].av.getAlignmentView (d);
if (!d) {
a = 0;
b = this.b$["jalview.appletgui.TreePanel"].av.getAlignment ().getWidth ();
c = this.b$["jalview.appletgui.TreePanel"].av.getAlignment ().getSequencesArray ();
} else {
a = this.b$["jalview.appletgui.TreePanel"].av.getSelectionGroup ().getStartRes ();
b = this.b$["jalview.appletgui.TreePanel"].av.getSelectionGroup ().getEndRes () + 1;
c = this.b$["jalview.appletgui.TreePanel"].av.getSelectionGroup ().getSequencesInOrder (this.b$["jalview.appletgui.TreePanel"].av.getAlignment ());
}var f = jalview.schemes.ResidueProperties.getScoreModel (this.b$["jalview.appletgui.TreePanel"].pwtype);
if (Clazz.instanceOf (f, jalview.api.analysis.ViewBasedAnalysisI)) {
try {
f = f.getClass ().newInstance ();
(f).configureFromAlignmentView (this.b$["jalview.appletgui.TreePanel"].treeCanvas.ap);
} catch (q) {
if (Clazz.exceptionOf (q, Exception)) {
System.err.println ("Couldn't create a scoremodel instance for " + f.getName ());
q.printStackTrace ();
} else {
throw q;
}
}
this.b$["jalview.appletgui.TreePanel"].tree =  new jalview.analysis.NJTree (c, e, this.b$["jalview.appletgui.TreePanel"].$type, this.b$["jalview.appletgui.TreePanel"].pwtype, f, a, b);
} else {
this.b$["jalview.appletgui.TreePanel"].tree =  new jalview.analysis.NJTree (c, e, this.b$["jalview.appletgui.TreePanel"].$type, this.b$["jalview.appletgui.TreePanel"].pwtype, null, a, b);
}}this.b$["jalview.appletgui.TreePanel"].tree.reCount (this.b$["jalview.appletgui.TreePanel"].tree.getTopNode ());
this.b$["jalview.appletgui.TreePanel"].tree.findHeight (this.b$["jalview.appletgui.TreePanel"].tree.getTopNode ());
this.b$["jalview.appletgui.TreePanel"].treeCanvas.setTree (this.b$["jalview.appletgui.TreePanel"].tree);
if (this.newtree != null) {
var a = this.newtree.HasDistances () && this.b$["jalview.appletgui.TreePanel"].av.applet.getDefaultParameter ("showTreeDistances", this.newtree.HasDistances ());
var b = this.newtree.HasBootstrap () && this.b$["jalview.appletgui.TreePanel"].av.applet.getDefaultParameter ("showTreeBootstraps", this.newtree.HasBootstrap ());
this.b$["jalview.appletgui.TreePanel"].distanceMenu.setState (a);
this.b$["jalview.appletgui.TreePanel"].bootstrapMenu.setState (b);
this.b$["jalview.appletgui.TreePanel"].treeCanvas.setShowBootstrap (b);
this.b$["jalview.appletgui.TreePanel"].treeCanvas.setShowDistances (a);
this.b$["jalview.appletgui.TreePanel"].treeCanvas.setMarkPlaceholders (this.b$["jalview.appletgui.TreePanel"].av.applet.getDefaultParameter ("showUnlinkedTreeNodes", false));
}this.b$["jalview.appletgui.TreePanel"].treeCanvas.repaint ();
this.b$["jalview.appletgui.TreePanel"].av.setCurrentTree (this.b$["jalview.appletgui.TreePanel"].tree);
});
c$ = Clazz.p0p ();
};
});
