Clazz.declarePackage ("jalview.workers");
Clazz.load (["jalview.api.AlignCalcWorkerI", "jalview.workers.AlignCalcWorker"], "jalview.workers.ConsensusThread", ["jalview.analysis.AAFrequency", "java.lang.Thread"], function () {
c$ = Clazz.declareType (jalview.workers, "ConsensusThread", jalview.workers.AlignCalcWorker, jalview.api.AlignCalcWorkerI);
Clazz.overrideMethod (c$, "run", 
function () {
if (this.calcMan.isPending (this)) {
return;
}this.calcMan.notifyStart (this);
var started = System.currentTimeMillis ();
try {
var consensus = this.getConsensusAnnotation ();
if (consensus == null || this.calcMan.isPending (this)) {
this.calcMan.workerComplete (this);
return;
}while (!this.calcMan.notifyWorking (this)) {
try {
if (this.ap != null) {
this.ap.paintAlignment (false);
}Thread.sleep (200);
} catch (ex) {
if (Clazz.exceptionOf (ex, Exception)) {
ex.printStackTrace ();
} else {
throw ex;
}
}
}
if (this.alignViewport.isClosed ()) {
this.abortAndDestroy ();
return;
}var alignment = this.alignViewport.getAlignment ();
var aWidth = -1;
if (alignment == null || (aWidth = alignment.getWidth ()) < 0) {
this.calcMan.workerComplete (this);
return;
}this.eraseConsensus (aWidth);
this.computeConsensus (alignment);
this.updateResultAnnotation (true);
if (this.ap != null) {
this.ap.paintAlignment (true);
}} catch (error) {
if (Clazz.exceptionOf (error, OutOfMemoryError)) {
this.calcMan.workerCannotRun (this);
this.ap.raiseOOMWarning ("calculating consensus", error);
} else {
throw error;
}
} finally {
this.calcMan.workerComplete (this);
}
});
Clazz.defineMethod (c$, "eraseConsensus", 
function (aWidth) {
var consensus = this.getConsensusAnnotation ();
consensus.annotations =  new Array (aWidth);
}, "~N");
Clazz.defineMethod (c$, "computeConsensus", 
function (alignment) {
var hconsensus =  new Array (alignment.getWidth ());
var aseqs = this.getSequences ();
jalview.analysis.AAFrequency.calculate (aseqs, 0, alignment.getWidth (), hconsensus, true);
this.alignViewport.setSequenceConsensusHash (hconsensus);
this.setColourSchemeConsensus (hconsensus);
}, "jalview.datamodel.AlignmentI");
Clazz.defineMethod (c$, "getSequences", 
function () {
return this.alignViewport.getAlignment ().getSequencesArray ();
});
Clazz.defineMethod (c$, "setColourSchemeConsensus", 
function (hconsensus) {
var globalColourScheme = this.alignViewport.getGlobalColourScheme ();
if (globalColourScheme != null) {
globalColourScheme.setConsensus (hconsensus);
}}, "~A");
Clazz.defineMethod (c$, "getConsensusAnnotation", 
function () {
return this.alignViewport.getAlignmentConsensusAnnotation ();
});
Clazz.overrideMethod (c$, "updateAnnotation", 
function () {
this.updateResultAnnotation (false);
});
Clazz.defineMethod (c$, "updateResultAnnotation", 
function (immediate) {
var consensus = this.getConsensusAnnotation ();
var hconsensus = this.getViewportConsensus ();
if (immediate || !this.calcMan.isWorking (this) && consensus != null && hconsensus != null) {
this.deriveConsensus (consensus, hconsensus);
}}, "~B");
Clazz.defineMethod (c$, "deriveConsensus", 
function (consensusAnnotation, consensusData) {
var nseq = this.getSequences ().length;
jalview.analysis.AAFrequency.completeConsensus (consensusAnnotation, consensusData, 0, consensusData.length, this.alignViewport.isIgnoreGapsConsensus (), this.alignViewport.isShowSequenceLogo (), nseq);
}, "jalview.datamodel.AlignmentAnnotation,~A");
Clazz.defineMethod (c$, "getViewportConsensus", 
function () {
return this.alignViewport.getSequenceConsensusHash ();
});
});
